package com.jakubu9333.grammarManager.dao;


import com.jakubu9333.grammarManager.model.Grammar;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Repository;

import java.util.List;


/**
 * @author Jakub Uhlarik
 */
@Repository
public interface GrammarRepository extends JpaRepository<Grammar, Long> {
    List<Grammar> findByUriStartingWith(String uri);

    List<Grammar> findAllByRootSymbol(String rootSymbol);

    Boolean existsByUriAndIdNot(String uri, Long id);
}
