package com.jakubu9333.grammarManager.dao;

import com.jakubu9333.grammarManager.model.XmlGrammar;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * @author Jakub Uhlarik
 */
public interface XmlDataRepo  extends JpaRepository< XmlGrammar,Long> {

    @Query(value = "SELECT text((xpath('*[local-name()=\"grammar\"]',xml_data))[1]) FROM xml_grammar WHERE text((xpath('*[local-name()=\"grammar\"]/@root',xml_data))[1])=:root", nativeQuery = true)
    List<String> findXmlDataByRoot(@Param("root") String root);


    @Query(value = "SELECT text((xpath(:val,xml_data))[1]) FRom xml_grammar WHERE (xmlexists(:val PASSING BY REF xml_data))", nativeQuery = true)
    List<String> findRuleBy(String val);




}
