package com.jakubu9333.grammarManager.model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonView;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.PreRemove;
import javax.persistence.PreUpdate;
import javax.persistence.SequenceGenerator;
import java.time.LocalDateTime;

/**
 * @author Jakub Uhlarik
 */
@Entity
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
public class FileHolder {

    @Id
    @JsonView(View.All.class)
    @SequenceGenerator(name = "file_sequence", allocationSize = 1, sequenceName = "file_sequence")
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "file_sequence")
    private Long id;


    @Column(columnDefinition = "text")
    private String text;

    @JsonView(View.All.class)
    private boolean xml;


    @JsonView(View.All.class)
    private long size;

    @OneToOne(mappedBy = "file")
    private Grammar grammar;

    private LocalDateTime createTime;


    public FileHolder(boolean xml, Grammar grammar, String text) {
        this.xml = xml;
        this.grammar = grammar;
        this.text = text;
    }

    @PreUpdate
    public void prePersist() {
        this.createTime = LocalDateTime.now();
    }

}
