package com.jakubu9333.grammarManager.model;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

/**
 * @author Jakub Uhlarik
 */
@Entity
@Table(name="xml_grammar")
@Setter
@Getter
@NoArgsConstructor
@AllArgsConstructor
public class XmlGrammar {
    @Id
    @SequenceGenerator(name = "xml_sequence", allocationSize = 1, sequenceName = "xml_sequence")
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "xml_sequence")
    private Long id;

    @Column(name = "xml_data",columnDefinition="xml")
    private String xml;

    public XmlGrammar(String xml) {
        this.xml=xml;
    }
}
